Index: GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPParticles/GTP_HPS.hlsl
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPParticles/GTP_HPS.hlsl	(revision 2327)
+++ GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPParticles/GTP_HPS.hlsl	(revision 2328)
@@ -313,5 +313,5 @@
 
 float4 HPS_Large_Depth_Illum_PS(VS_OUT_DEPTH_ILLUM IN,
-						uniform float nearPlane,
+						uniform float nearplane,
 						uniform sampler2D Texture  : register(s0),
 						uniform sampler2D depthTexture : register(s1),
@@ -339,8 +339,8 @@
 		float backDepth = IN.cPosition.z +  size * (b - 0.5);
 		float B = min(sceneDepth, backDepth);
-		float F = max(frontDepth, nearPlane);
+		float F = max(frontDepth, 0.01);
 		float ds = B - F;
 		alpha = ds / (backDepth - frontDepth);
-		alpha = saturate(alpha) * impostor.a;
+		alpha =saturate(alpha) * impostor.a;
 	}
 ///identify light volume slices and interpolation	
@@ -399,4 +399,2 @@
     return Color;	
 }
-
-
Index: GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPParticles/GTP_Particles.program
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPParticles/GTP_Particles.program	(revision 2024)
+++ GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPParticles/GTP_Particles.program	(revision 2328)
@@ -111,2 +111,3 @@
 	target ps_2_0
 }
+
Index: GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPParticles/GTP_Particles.material
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPParticles/GTP_Particles.material	(revision 2327)
+++ GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPParticles/GTP_Particles.material	(revision 2328)
@@ -226,5 +226,5 @@
 			fragment_program_ref GTP/HPS/Large_Depth_Illum_PS
 			{ 
-				param_named_auto nearPlane near_clip_distance
+				param_named_auto nearplane near_clip_distance
 			}			
 			//impostor texture
@@ -246,4 +246,6 @@
 	}
 }
+
+
 
 material GTP/HPS/Smoke_IllumVolume
Index: GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPPostProc/GTPPlain.compositor
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPPostProc/GTPPlain.compositor	(revision 2328)
+++ GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPPostProc/GTPPlain.compositor	(revision 2328)
@@ -0,0 +1,25 @@
+compositor GTP/PostProc/Plain
+{
+    technique
+    {
+        texture scene target_width target_height PF_FLOAT16_RGBA
+    	
+	target scene
+        {
+            input previous		 
+        }
+
+       target_output
+       {
+         input none
+	 pass clear
+	 {
+	 }          
+         pass render_quad
+         {
+               material GTP/PostProc/Copy
+               input 0 scene               
+         }
+       }
+    }
+}
Index: GTP/trunk/App/Demos/Illum/Ogre/Media/MORIA/Particles.particle
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/Media/MORIA/Particles.particle	(revision 2326)
+++ GTP/trunk/App/Demos/Illum/Ogre/Media/MORIA/Particles.particle	(revision 2328)
@@ -4,8 +4,8 @@
 	
 	material		GTP/Moria/Smoke_L_Depth_Illum
-	particle_width  2.2
-    particle_height 2.2
+	particle_width  4.2
+    particle_height 4.2
     cull_each       false
-    quota           600
+    quota           700
     sorted			true
     //billboard_type  point
@@ -19,5 +19,5 @@
 
         angle           30
-        emission_rate   10
+        emission_rate   15
         time_to_live    10
         direction       0 1 0
@@ -25,12 +25,12 @@
         width           20       
         height          20
-        depth           0.8
+        depth           0.6
     }
  
     affector ColourFader2
     {
-       alpha1 +0.1
-       alpha2 -0.1
-       state_change 0.5
+       alpha1 +0.15
+       alpha2 -0.15
+       state_change 5
     }
 }
@@ -41,6 +41,6 @@
 	material        GTP/HPS/Smoke_S
 	renderer sprite
-    particle_width  2.5
-    particle_height 2.5
+    particle_width  1.5
+    particle_height 1.5
     cull_each       false
     quota           400
@@ -57,5 +57,5 @@
         time_to_live    6
         direction       0 1 0
-        velocity    	0.5 
+        velocity    	0.25 
         
         width           0.5        